import "./App.css";

import {
  BryntumSchedulerProProps,
  BryntumSchedulerPro,
} from "@bryntum/schedulerpro-react";
import { useEffect } from "react";
import { useState } from "react";
import resourcesData from "./resources_data.json";
import eventsDataWithSegments from "./event_data.json";
import assignmentsData from "./assignments_data.json";

const eventsData = eventsDataWithSegments;

const schedulerProConfig: BryntumSchedulerProProps = {
  startDate: new Date("2023-05-01"),
  endDate: new Date("2023-05-31"),
  project: {
    calendar: "calendar",
    skipNonWorkingTimeInDurationWhenSchedulingManually: false,
  },
  eventTooltipFeature: {
    anchorToTarget: false,
    allowOver: true,
    template: () => (
      <select>
        <option>Hello world</option>
      </select>
    ),
  },
};

function App() {
  const [events, setEvents] = useState(eventsData);
  const [assignments, setAssignments] = useState(assignmentsData);
  const [resources, setResources] = useState(resourcesData);

  useEffect(() => {
    const id = setInterval(() => {
      console.log("Updating data");
      setEvents((oldEventsData) =>
        JSON.parse(
          JSON.stringify(
            oldEventsData.map((event) => {
              if (event.name === "disintermediate frictionless niches") {
                return {
                  ...event,
                  endDate:
                    event.endDate === "2023-05-20T12:47:00"
                      ? "2023-05-21T12:47:00"
                      : "2023-05-20T12:47:00",
                };
              }
              return event;
            })
          )
        )
      );
      setAssignments(JSON.parse(JSON.stringify(assignmentsData)));
      setResources(JSON.parse(JSON.stringify(resourcesData)));
    }, 1000);
    return () => {
      clearInterval(id);
    };
  }, []);

  console.log("Events", events);

  return (
    <>
      <BryntumSchedulerPro
        {...schedulerProConfig}
        resources={resources}
        assignments={assignments}
        events={events}
      />
    </>
  );
}

export default App;
